Lorene::Star_rot Class Reference
Stars and black holes

Class for isolated rotating stars. More...

`#include <star_rot.h>`

Inheritance diagram for Lorene::Star_rot:

## Public Member Functions

| Star_rot (Map &mp_i, int nzet_i, bool relat, const Eos &eos_i)
| Standard constructor.
| Star_rot (const Star_rot &)
| Copy constructor.
| Star_rot (Map &mp_i, const Eos &eos_i, FILE *fich)
| Constructor from a file (see `sauve(FILE*)` ).
virtual | ~Star_rot ()
| Destructor.
void | operator= (const Star_rot &)
| Assignment to another `Star_rot`.
bool | is_relativistic () const
| Returns `true` for a relativistic star, `false` for a Newtonian one.
virtual double | get_omega_c () const
| Returns the central value of the rotation angular velocity (``[f_unit] ).
const Scalar & | get_bbb () const
| Returns the metric factor B.
const Scalar & | get_a_car () const
| Returns the square of the metric factor A.
const Scalar & | get_b_car () const
| Returns the square of the metric factor B.
const Scalar & | get_nphi () const
| Returns the metric coefficient .
const Scalar & | get_tnphi () const
| Returns the component of the shift vector.
const Scalar & | get_uuu () const
| Returns the norm of `u_euler`.
const Scalar & | get_nuf () const
| Returns the part of the Metric potential = `logn` generated by the matter terms.
const Scalar & | get_nuq () const
| Returns the Part of the Metric potential = `logn` generated by the quadratic terms.
const Scalar & | get_dzeta () const
| Returns the Metric potential .
const Scalar & | get_tggg () const
| Returns the Metric potential .
const Vector & | get_w_shift () const
| Returns the vector used in the decomposition of `shift` , following Shibata's prescription [Prog.
const Scalar & | get_khi_shift () const
| Returns the scalar used in the decomposition of `shift` following Shibata's prescription [Prog.
const Sym_tensor & | get_tkij () const
| Returns the tensor related to the extrinsic curvature tensor by .
const Scalar & | get_ak_car () const
| Returns the scalar .
virtual void | sauve (FILE *) const
| Save in a file.
virtual void | display_poly (ostream &) const
| Display in polytropic units.
virtual const Itbl & | l_surf () const
| Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
virtual double | mass_b () const
| Baryon mass.
virtual double | mass_g () const
| Gravitational mass.
virtual double | angu_mom () const
| Angular momentum.
virtual double | tsw () const
| Ratio T/W.
virtual double | grv2 () const
| Error on the virial identity GRV2.
virtual double | grv3 (ostream *ost=0x0) const
| Error on the virial identity GRV3.
virtual double | r_circ () const
| Circumferential radius.
virtual double | aplat () const
| Flatening r_pole/r_eq.
virtual double | area () const
| Integrated surface area in .
virtual double | mean_radius () const
| Mean star radius from the area .
virtual double | z_eqf () const
| Forward redshift factor at equator.
virtual double | z_eqb () const
| Backward redshift factor at equator.
virtual double | z_pole () const
| Redshift factor at North pole.
virtual double | mom_quad () const
| Quadrupole moment.
virtual double | r_isco (ostream *ost=0x0) const
| Circumferential radius of the innermost stable circular orbit (ISCO).
virtual double | f_isco () const
| Orbital frequency at the innermost stable circular orbit (ISCO).
virtual double | espec_isco () const
| Energy of a particle on the ISCO.
virtual double | lspec_isco () const
| Angular momentum of a particle on the ISCO.
virtual double | f_eq () const
| Orbital frequency at the equator.
virtual void | hydro_euler ()
| Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame.
void | update_metric ()
| Computes metric coefficients from known potentials.
void | fait_shift ()
| Computes `shift` from `w_shift` and `khi_shift` according to Shibata's prescription [Prog.
void | fait_nphi ()
| Computes `tnphi` and `nphi` from the Cartesian components of the shift, stored in `shift` .
void | extrinsic_curvature ()
| Computes `tkij` and `ak_car` from `shift` , `nnn` and `b_car` .
virtual void | equilibrium (double ent_c, double omega0, double fact_omega, int nzadapt, const Tbl &ent_limit, const Itbl &icontrol, const Tbl &control, double mbar_wanted, double aexp_mass, Tbl &diff, Param *=0x0)
| Computes an equilibrium configuration.
Map & | set_mp ()
| Read/write of the mapping.
void | set_enthalpy (const Scalar &)
| Assignment of the enthalpy field.
void | equation_of_state ()
| Computes the proper baryon and energy density, as well as pressure from the enthalpy.
virtual void | equilibrium_spher (double ent_c, double precis=1.e-14, const Tbl *pent_limit=0x0)
| Computes a spherical static configuration.
const Map & | get_mp () const
| Returns the mapping.
int | get_nzet () const
| Returns the number of domains occupied by the star.
const Eos & | get_eos () const
| Returns the equation of state.
const Scalar & | get_ent () const
| Returns the enthalpy field.
const Scalar & | get_nbar () const
| Returns the proper baryon density.
const Scalar & | get_ener () const
| Returns the proper total energy density.
const Scalar & | get_press () const
| Returns the fluid pressure.
const Scalar & | get_ener_euler () const
| Returns the total energy density with respect to the Eulerian observer.
const Scalar & | get_s_euler () const
| Returns the trace of the stress tensor in the Eulerian frame.
const Scalar & | get_gam_euler () const
| Returns the Lorentz factor between the fluid and Eulerian observers.
const Vector & | get_u_euler () const
| Returns the fluid 3-velocity with respect to the Eulerian observer.
const Tensor & | get_stress_euler () const
| Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.
const Scalar & | get_logn () const
| Returns the logarithm of the lapse N.
const Scalar & | get_nn () const
| Returns the lapse function N.
const Vector & | get_beta () const
| Returns the shift vector .
const Scalar & | get_lnq () const
const Metric & | get_gamma () const
| Returns the 3-metric .
double | ray_eq () const
| Coordinate radius at , [r_unit].
double | ray_eq_pis2 () const
| Coordinate radius at , [r_unit].
double | ray_eq_pi () const
| Coordinate radius at , [r_unit].
double | ray_eq_3pis2 () const
| Coordinate radius at , [r_unit].
double | ray_pole () const
| Coordinate radius at [r_unit].
const Tbl & | xi_surf () const
| Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

## Static Public Member Functions

static double | lambda_grv2 (const Scalar &sou_m, const Scalar &sou_q)
| Computes the coefficient which ensures that the GRV2 virial identity is satisfied.

## Protected Member Functions

virtual void | del_deriv () const
| Deletes all the derived quantities.
virtual void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual void | del_hydro_euler ()
| Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.
virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).
virtual void | partial_display (ostream &) const
| Printing of some informations, excluding all global quantities.

## Protected Attributes

bool | relativistic
| Indicator of relativity: `true` for a relativistic star, `false` for a Newtonian one.
double | unsurc2
| : `unsurc2=1` for a relativistic star, 0 for a Newtonian one.
double | omega
| Rotation angular velocity (``[f_unit] ).
Scalar | a_car
| Square of the metric factor A.
Scalar | bbb
| Metric factor B.
Scalar | b_car
| Square of the metric factor B.
Scalar | nphi
| Metric coefficient .
Scalar | tnphi
| Component of the shift vector.
Scalar | uuu
| Norm of `u_euler`.
Scalar | nuf
| Part of the Metric potential = `logn` generated by the matter terms.
Scalar | nuq
| Part of the Metric potential = `logn` generated by the quadratic terms.
Scalar | dzeta
| Metric potential .
Scalar | tggg
| Metric potential .
Vector | w_shift
| Vector used in the decomposition of `shift` , following Shibata's prescription [Prog.
Scalar | khi_shift
| Scalar used in the decomposition of `shift` , following Shibata's prescription [Prog.
Sym_tensor | tkij
| Tensor related to the extrinsic curvature tensor by .
Scalar | ak_car
| Scalar .
Scalar | ssjm1_nuf
| Effective source at the previous step for the resolution of the Poisson equation for `nuf` by means of `Map_et::poisson` .
Scalar | ssjm1_nuq
| Effective source at the previous step for the resolution of the Poisson equation for `nuq` by means of `Map_et::poisson` .
Scalar | ssjm1_dzeta
| Effective source at the previous step for the resolution of the Poisson equation for `dzeta` .
Scalar | ssjm1_tggg
| Effective source at the previous step for the resolution of the Poisson equation for `tggg` .
Scalar | ssjm1_khi
| Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .
Vector | ssjm1_wshift
| Effective source at the previous step for the resolution of the vector Poisson equation for .
double * | p_angu_mom
| Angular momentum.
double * | p_tsw
| Ratio T/W.
double * | p_grv2
| Error on the virial identity GRV2.
double * | p_grv3
| Error on the virial identity GRV3.
double * | p_r_circ
| Circumferential radius.
double * | p_aplat
| Flatening r_pole/r_eq.
double * | p_area
| Integrated surface area.
double * | p_z_eqf
| Forward redshift factor at equator.
double * | p_z_eqb
| Backward redshift factor at equator.
double * | p_z_pole
| Redshift factor at North pole.
double * | p_mom_quad
| Quadrupole moment.
double * | p_r_isco
| Circumferential radius of the ISCO.
double * | p_f_isco
| Orbital frequency of the ISCO.
double * | p_espec_isco
| Specific energy of a particle on the ISCO.
double * | p_lspec_isco
| Specific angular momentum of a particle on the ISCO.
double * | p_f_eq
| Orbital frequency at the equator.
Map & | mp
| Mapping associated with the star.
int | nzet
| Number of domains of `*mp` occupied by the star.
const Eos & | eos
| Equation of state of the stellar matter.
Scalar | ent
| Log-enthalpy.
Scalar | nbar
| Baryon density in the fluid frame.
Scalar | ener
| Total energy density in the fluid frame.
Scalar | press
| Fluid pressure.
Scalar | ener_euler
| Total energy density in the Eulerian frame.
Scalar | s_euler
| Trace of the stress scalar in the Eulerian frame.
Scalar | gam_euler
| Lorentz factor between the fluid and Eulerian observers.
Vector | u_euler
| Fluid 3-velocity with respect to the Eulerian observer.
Sym_tensor | stress_euler
| Spatial part of the stress-energy tensor with respect to the Eulerian observer.
Scalar | logn
| Logarithm of the lapse N .
Scalar | nn
| Lapse function N .
Vector | beta
| Shift vector.
Scalar | lnq
Metric | gamma
| 3-metric
double * | p_ray_eq
| Coordinate radius at , .
double * | p_ray_eq_pis2
| Coordinate radius at , .
double * | p_ray_eq_pi
| Coordinate radius at , .
double * | p_ray_eq_3pis2
| Coordinate radius at , .
double * | p_ray_pole
| Coordinate radius at .
Itbl * | p_l_surf
| Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
Tbl * | p_xi_surf
| Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .
double * | p_mass_b
| Baryon mass.
double * | p_mass_g
| Gravitational mass.

## Detailed Description

Class for isolated rotating stars.

()

The metric is

A star of class `Star_rot` can be either relativistic or Newtonian, depending on the boolean indicator `relativistic` . For a Newtonian star, the metric coefficients N, A, and B are set to 1, and is set to zero; the only relevant gravitational quantity in this case is `logn` which represents the Newtonian gravitational potential generated by the star.

Version

Id
  star_rot.h,v 1.6 2015/05/19 09:30:55 j_novak Exp

Definition at line 86 of file star_rot.h.

## Constructor & Destructor Documentation

## Star_rot() [1/3]

Lorene::Star_rot::Star_rot | ( | Map & | mp_i,
|  | int | nzet_i,
|  | bool | relat,
|  | const Eos & | eos_i )

Standard constructor.

Parameters

  mp_i | Mapping on which the star is contructed
  nzet_i | Number of domains occupied by the star
  relat | `true` for a relativistic star, `false` for a Newtonian one
  eos_i | Equation of state of the stellar matter

Definition at line 86 of file star_rot.C.

References a_car, ak_car, b_car, bbb, Lorene::Star::beta, dzeta, Lorene::get_bvect_cart(), khi_shift, Lorene::Map(), Lorene::Star::mp, nphi, nuf, nuq, omega, relativistic, set_der_0x0(), ssjm1_dzeta, ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, Lorene::Star::Star(), tggg, tkij, tnphi, unsurc2, uuu, and w_shift.

## Star_rot() [2/3]

Lorene::Star_rot::Star_rot | ( | const Star_rot & | et | ) |

Copy constructor.

Definition at line 156 of file star_rot.C.

References a_car, ak_car, b_car, bbb, dzeta, khi_shift, nphi, nuf, nuq, omega, relativistic, set_der_0x0(), ssjm1_dzeta, ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, Lorene::Star::Star(), Star_rot(), tggg, tkij, tnphi, unsurc2, uuu, and w_shift.

## Star_rot() [3/3]

Lorene::Star_rot::Star_rot | ( | Map & | mp_i,
|  | const Eos & | eos_i,
|  | FILE * | fich )

Constructor from a file (see `sauve(FILE*)` ).

Parameters

  mp_i | Mapping on which the star is constructed
  eos_i | Equation of state of the stellar matter
  fich | input file (must have been created by the function `Star_rot::sauve` )

Definition at line 189 of file star_rot.C.

References a_car, ak_car, b_car, bbb, dzeta, fait_nphi(), fait_shift(), Lorene::fread_be(), Lorene::get_bvect_cart(), khi_shift, Lorene::Map(), Lorene::Star::mp, nphi, nuf, nuq, omega, relativistic, set_der_0x0(), ssjm1_dzeta, ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, Lorene::Star::Star(), tggg, tkij, tnphi, unsurc2, uuu, and w_shift.

## ~Star_rot()

Lorene::Star_rot::~Star_rot | ( |  | ) |

virtual

Destructor.

Definition at line 287 of file star_rot.C.

References del_deriv().

## Member Function Documentation

## angu_mom()

double Lorene::Star_rot::angu_mom | ( |  | ) | const

virtual

Angular momentum.

Definition at line 150 of file star_rot_global.C.

References a_car, b_car, Lorene::Star::ener_euler, Lorene::Scalar::get_spectral_va(), Lorene::Scalar::integrale(), Lorene::Scalar::mult_r(), Lorene::Valeur::mult_st(), Lorene::Star::nbar, p_angu_mom, Lorene::Star::press, relativistic, Lorene::Scalar::set_spectral_va(), and uuu.

## aplat()

double Lorene::Star_rot::aplat | ( |  | ) | const

virtual

Flatening r_pole/r_eq.

Definition at line 426 of file star_rot_global.C.

References p_aplat, Lorene::Star::ray_eq(), and Lorene::Star::ray_pole().

## area()

double Lorene::Star_rot::area | ( |  | ) | const

virtual

Integrated surface area in .

Definition at line 366 of file star_rot_global.C.

References Lorene::Valeur::annule_hard(), Lorene::Valeur::c_cf, Lorene::Valeur::dsdt(), get_a_car(), Lorene::Mg3d::get_angu(), get_bbb(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Scalar::get_spectral_va(), l_surf(), Lorene::Star::mp, Lorene::Valeur::mult_st(), p_area, Lorene::Valeur::set(), Lorene::sqrt(), Lorene::Valeur::std_base_scal(), Lorene::Valeur::val_point_jk(), Lorene::Map_radial::val_r_jk(), and Lorene::Star::xi_surf().

## del_deriv()

void Lorene::Star_rot::del_deriv | ( |  | ) | const

protected virtual

Deletes all the derived quantities.

Reimplemented from Lorene::Star.

Definition at line 297 of file star_rot.C.

References Lorene::Star::del_deriv(), p_angu_mom, p_aplat, p_area, p_espec_isco, p_f_eq, p_f_isco, p_grv2, p_grv3, p_lspec_isco, p_mom_quad, p_r_circ, p_r_isco, p_tsw, p_z_eqb, p_z_eqf, p_z_pole, and set_der_0x0().

## del_hydro_euler()

void Lorene::Star_rot::del_hydro_euler | ( |  | ) |

protected virtual

Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.

Reimplemented from Lorene::Star.

Definition at line 345 of file star_rot.C.

References del_deriv(), and Lorene::Star::del_hydro_euler().

## display_poly()

void Lorene::Star_rot::display_poly | ( | ostream & | ost | ) | const

virtual

Display in polytropic units.

Definition at line 649 of file star_rot.C.

References angu_mom(), Lorene::Star::ener, Lorene::Star::eos, Lorene::Eos_poly::get_gam(), Lorene::Eos_poly::get_kap(), get_omega_c(), mass_b(), mass_g(), mean_radius(), Lorene::Star::nbar, Lorene::pow(), r_circ(), Lorene::Star::ray_eq(), and Lorene::sqrt().

## equation_of_state()

void Lorene::Star::equation_of_state | ( |  | ) |

inherited

Computes the proper baryon and energy density, as well as pressure from the enthalpy.

Definition at line 462 of file star.C.

References Lorene::Param::add_int(), Lorene::Scalar::allocate_all(), del_deriv(), ener, ent, eos, Lorene::Mg3d::get_grille3d(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), mp, nbar, nzet, press, Lorene::Mtbl::set(), Lorene::Scalar::set_domain(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::std_spectral_base(), Lorene::Mtbl::t, and Lorene::Grille3d::x.

## equilibrium()

void Lorene::Star_rot::equilibrium | ( | double | ent_c,
|  | double | omega0,
|  | double | fact_omega,
|  | int | nzadapt,
|  | const Tbl & | ent_limit,
|  | const Itbl & | icontrol,
|  | const Tbl & | control,
|  | double | mbar_wanted,
|  | double | aexp_mass,
|  | Tbl & | diff,
|  | Param * | = 0x0 )

virtual

Computes an equilibrium configuration.

Parameters

  ent_c | [input] Central enthalpy
  omega0 | [input] Requested angular velocity (if `fact_omega=1`. )

  fact_omega

  [input] 1.01 = search for the Keplerian frequency,
  1. = otherwise.

  nzadapt | [input] Number of (inner) domains where the mapping adaptation to an iso-enthalpy surface should be performed
  ent_limit | [input] 1-D `Tbl` of dimension `nzet` which defines the enthalpy at the outer boundary of each domain

  icontrol

  [input] Set of integer parameters (stored as a 1-D `Itbl` of size 8) to control the iteration:
  - `icontrol(0)` = mer_max : maximum number of steps
  - `icontrol(1)` = mer_rot : step at which the rotation is switched on
  - `icontrol(2)` = mer_change_omega : step at which the rotation velocity is changed to reach the final one
  - `icontrol(3)` = mer_fix_omega : step at which the final rotation velocity must have been reached
  - `icontrol(4)` = mer_mass : the absolute value of `mer_mass` is the step from which the baryon mass is forced to converge, by varying the central enthalpy (`mer_mass>0` ) or the angular velocity (`mer_mass<0` )
  - `icontrol(5)` = mermax_poisson : maximum number of steps in `Map_et::poisson`
  - `icontrol(6)` = mer_triax : step at which the 3-D perturbation is switched on
  - `icontrol(7)` = delta_mer_kep : number of steps after `mer_fix_omega` when `omega` starts to be increased by `fact_omega` to search for the Keplerian velocity

  control

  [input] Set of parameters (stored as a 1-D `Tbl` of size 7) to control the iteration:
  - `control(0)` = precis : threshold on the enthalpy relative change for ending the computation
  - `control(1)` = omega_ini : initial angular velocity, switched on only if `mer_rot<0` , otherwise 0 is used
  - `control(2)` = relax : relaxation factor in the main iteration
  - `control(3)` = relax_poisson : relaxation factor in `Map_et::poisson`
  - `control(4)` = thres_adapt : threshold on dH/dr for freezing the adaptation of the mapping
  - `control(5)` = ampli_triax : relative amplitude of the 3-D perturbation
  - `control(6)` = precis_adapt : precision for `Map_et::adapt`

  mbar_wanted | [input] Requested baryon mass (effective only if `mer_mass` > `mer_max` )
  aexp_mass | [input] Exponent for the increase factor of the central enthalpy to converge to the requested baryon mass

  diff

  [output] 1-D `Tbl` of size 7 for the storage of some error indicators :
  - `diff(0)` : Relative change in the enthalpy field between two successive steps
  - `diff(1)` : Relative error in the resolution of the Poisson equation for `nuf`
  - `diff(2)` : Relative error in the resolution of the Poisson equation for `nuq`
  - `diff(3)` : Relative error in the resolution of the Poisson equation for `dzeta`
  - `diff(4)` : Relative error in the resolution of the Poisson equation for `tggg`
  - `diff(5)` : Relative error in the resolution of the equation for `shift` (x comp.)
  - `diff(6)` : Relative error in the resolution of the equation for `shift` (y comp.)

Definition at line 71 of file star_rot_equil.C.

References a_car, Lorene::abs(), Lorene::Param::add_cmp_mod(), Lorene::Param::add_double(), Lorene::Param::add_double_mod(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::Param::add_tenseur_mod(), ak_car, Lorene::Tensor::annule_domain(), bbb, Lorene::Star::beta, Lorene::Valeur::c_cf, Lorene::Vector::change_triad(), Lorene::Valeur::coef(), Lorene::contract(), Lorene::cos(), Lorene::Scalar::derive_con(), Lorene::Scalar::derive_cov(), Lorene::diffrel(), dzeta, Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::Star::equation_of_state(), fait_nphi(), Lorene::Star::gam_euler, Lorene::Valeur::get_base(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Scalar::get_spectral_va(), Lorene::Mg3d::get_type_t(), grv2(), Lorene::Map_et::homothetie(), hydro_euler(), khi_shift, Lorene::log(), Lorene::log10(), Lorene::Star::logn, mass_b(), mass_g(), Lorene::Star::mp, Lorene::Scalar::mult_rsint(), Lorene::Star::nbar, Lorene::Star::nn, nphi, nuf, nuq, Lorene::Star::nzet, omega, partial_display(), Lorene::phi, Lorene::Scalar::poisson(), Lorene::Tenseur::poisson_vect(), Lorene::pow(), Lorene::Star::press, Lorene::Star::ray_eq(), Lorene::Star::ray_pole(), relativistic, Lorene::Star::s_euler, Lorene::Tbl::set(), Lorene::Tenseur::set(), Lorene::Vector::set(), Lorene::Tbl::set_etat_qcq(), Lorene::Tenseur::set_etat_qcq(), Lorene::Cmp::set_etat_zero(), Lorene::sint, Lorene::sqrt(), ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, Lorene::Scalar::std_spectral_base(), Lorene::Scalar::test_poisson(), tggg, tkij, Lorene::Star::u_euler, Lorene::Tensor::up(), update_metric(), uuu, Lorene::Scalar::val_grid_point(), and w_shift.

## equilibrium_spher()

void Lorene::Star::equilibrium_spher | ( | double | ent_c,
|  | double | precis = 1.e-14,
|  | const Tbl * | pent_limit = 0x0 )

virtual inherited

Computes a spherical static configuration.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)
  ent_limit | [input] : array of enthalpy values to be set at the boundaries between the domains; if set to 0x0 (default), the initial values will be kept.

Definition at line 95 of file star_equil_spher.C.

References Lorene::Map_et::adapt(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::diffrel(), Lorene::Map_af::dsdr(), Lorene::Scalar::dsdr(), ener, ener_euler, ent, equation_of_state(), Lorene::exp(), gam_euler, gamma, Lorene::Map_af::get_alpha(), Lorene::Map_et::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Map_et::get_beta(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), Lorene::Scalar::integrale(), logn, mass_b(), mass_g(), mp, nn, Lorene::norme(), nzet, Lorene::Map_af::poisson(), press, s_euler, Lorene::Tensor::set(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Scalar::set_dzpuis(), Lorene::Cmp::set_etat_qcq(), Lorene::Tensor::set_etat_zero(), Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), u_euler, and Lorene::Scalar::val_grid_point().

## espec_isco()

double Lorene::Star_rot::espec_isco | ( |  | ) | const

virtual

Energy of a particle on the ISCO.

Definition at line 289 of file star_rot_isco.C.

References p_espec_isco, and r_isco().

## extrinsic_curvature()

void Lorene::Star_rot::extrinsic_curvature | ( |  | ) |

Computes `tkij` and `ak_car` from `shift` , `nnn` and `b_car` .

Definition at line 110 of file star_rot_upmetr.C.

References ak_car, b_car, Lorene::Star::beta, Lorene::contract(), Lorene::Scalar::get_etat(), Lorene::Scalar::get_spectral_va(), Lorene::Star::mp, Lorene::Valeur::mult_ct(), Lorene::Scalar::mult_rsint(), Lorene::Valeur::mult_st(), Lorene::Star::nn, nphi, Lorene::Scalar::set_spectral_va(), and tkij.

## f_eq()

double Lorene::Star_rot::f_eq | ( |  | ) | const

virtual

Orbital frequency at the equator.

Definition at line 307 of file star_rot_isco.C.

References p_f_eq, and r_isco().

## f_isco()

double Lorene::Star_rot::f_isco | ( |  | ) | const

virtual

Orbital frequency at the innermost stable circular orbit (ISCO).

Definition at line 255 of file star_rot_isco.C.

References p_f_isco, and r_isco().

## fait_nphi()

void Lorene::Star_rot::fait_nphi | ( |  | ) |

Computes `tnphi` and `nphi` from the Cartesian components of the shift, stored in `shift` .

Definition at line 748 of file star_rot.C.

References Lorene::Star::beta, Lorene::Star::mp, nphi, and tnphi.

## fait_shift()

void Lorene::Star_rot::fait_shift | ( |  | ) |

Computes `shift` from `w_shift` and `khi_shift` according to Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

Definition at line 703 of file star_rot.C.

References Lorene::Star::beta, Lorene::contract(), Lorene::cost, Lorene::Tensor::dec_dzpuis(), Lorene::Scalar::domain(), khi_shift, Lorene::Star::mp, Lorene::Vector::set(), Lorene::Scalar::set_domain(), Lorene::Scalar::set_dzpuis(), Lorene::Vector::std_spectral_base(), and w_shift.

## get_a_car()

const Scalar & Lorene::Star_rot::get_a_car | ( |  | ) | const

inline

Returns the square of the metric factor A.

Definition at line 319 of file star_rot.h.

References a_car.

## get_ak_car()

const Scalar & Lorene::Star_rot::get_ak_car | ( |  | ) | const

inline

Returns the scalar .

For axisymmetric stars, this quantity is related to the derivatives of by

In particular it is related to the quantities and introduced by Eqs. (3.7) and (3.8) of Bonazzola et al. Astron. Astrophys. 278 , 421 (1993) by

Definition at line 403 of file star_rot.h.

References ak_car.

## get_b_car()

const Scalar & Lorene::Star_rot::get_b_car | ( |  | ) | const

inline

Returns the square of the metric factor B.

Definition at line 322 of file star_rot.h.

References b_car.

## get_bbb()

const Scalar & Lorene::Star_rot::get_bbb | ( |  | ) | const

inline

Returns the metric factor B.

Definition at line 316 of file star_rot.h.

References bbb.

## get_beta()

const Vector & Lorene::Star::get_beta | ( |  | ) | const

inline inherited

Returns the shift vector .

Definition at line 402 of file star.h.

References beta.

## get_dzeta()

const Scalar & Lorene::Star_rot::get_dzeta | ( |  | ) | const

inline

Returns the Metric potential .

Definition at line 346 of file star_rot.h.

References dzeta.

## get_ener()

const Scalar & Lorene::Star::get_ener | ( |  | ) | const

inline inherited

Returns the proper total energy density.

Definition at line 370 of file star.h.

References ener.

## get_ener_euler()

const Scalar & Lorene::Star::get_ener_euler | ( |  | ) | const

inline inherited

Returns the total energy density with respect to the Eulerian observer.

Definition at line 376 of file star.h.

References ener_euler.

## get_ent()

const Scalar & Lorene::Star::get_ent | ( |  | ) | const

inline inherited

Returns the enthalpy field.

Definition at line 364 of file star.h.

References ent.

## get_eos()

const Eos & Lorene::Star::get_eos | ( |  | ) | const

inline inherited

Returns the equation of state.

Definition at line 361 of file star.h.

References eos.

## get_gam_euler()

const Scalar & Lorene::Star::get_gam_euler | ( |  | ) | const

inline inherited

Returns the Lorentz factor between the fluid and Eulerian observers.

Definition at line 382 of file star.h.

References gam_euler.

## get_gamma()

const Metric & Lorene::Star::get_gamma | ( |  | ) | const

inline inherited

Returns the 3-metric .

Definition at line 409 of file star.h.

References gamma.

## get_khi_shift()

const Scalar & Lorene::Star_rot::get_khi_shift | ( |  | ) | const

inline

Returns the scalar used in the decomposition of `shift`
following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 377 of file star_rot.h.

References khi_shift.

## get_lnq()

const Scalar & Lorene::Star::get_lnq | ( |  | ) | const

inline inherited

Definition at line 406 of file star.h.

## get_logn()

const Scalar & Lorene::Star::get_logn | ( |  | ) | const

inline inherited

Returns the logarithm of the lapse N.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 396 of file star.h.

References logn.

## get_mp()

const Map & Lorene::Star::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 355 of file star.h.

References Lorene::Map(), and mp.

## get_nbar()

const Scalar & Lorene::Star::get_nbar | ( |  | ) | const

inline inherited

Returns the proper baryon density.

Definition at line 367 of file star.h.

References nbar.

## get_nn()

const Scalar & Lorene::Star::get_nn | ( |  | ) | const

inline inherited

Returns the lapse function N.

Definition at line 399 of file star.h.

References nn.

## get_nphi()

const Scalar & Lorene::Star_rot::get_nphi | ( |  | ) | const

inline

Returns the metric coefficient .

Definition at line 325 of file star_rot.h.

References nphi.

## get_nuf()

const Scalar & Lorene::Star_rot::get_nuf | ( |  | ) | const

inline

Returns the part of the Metric potential = `logn` generated by the matter terms.

Definition at line 338 of file star_rot.h.

References nuf.

## get_nuq()

const Scalar & Lorene::Star_rot::get_nuq | ( |  | ) | const

inline

Returns the Part of the Metric potential = `logn` generated by the quadratic terms.

Definition at line 343 of file star_rot.h.

References nuq.

## get_nzet()

int Lorene::Star::get_nzet | ( |  | ) | const

inline inherited

Returns the number of domains occupied by the star.

Definition at line 358 of file star.h.

References nzet.

## get_omega_c()

double Lorene::Star_rot::get_omega_c | ( |  | ) | const

virtual

Returns the central value of the rotation angular velocity (``[f_unit] ).

Definition at line 640 of file star_rot.C.

References omega.

## get_press()

const Scalar & Lorene::Star::get_press | ( |  | ) | const

inline inherited

Returns the fluid pressure.

Definition at line 373 of file star.h.

References press.

## get_s_euler()

const Scalar & Lorene::Star::get_s_euler | ( |  | ) | const

inline inherited

Returns the trace of the stress tensor in the Eulerian frame.

Definition at line 379 of file star.h.

References s_euler.

## get_stress_euler()

const Tensor & Lorene::Star::get_stress_euler | ( |  | ) | const

inline inherited

Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 390 of file star.h.

References stress_euler.

## get_tggg()

const Scalar & Lorene::Star_rot::get_tggg | ( |  | ) | const

inline

Returns the Metric potential .

Definition at line 349 of file star_rot.h.

References tggg.

## get_tkij()

const Sym_tensor & Lorene::Star_rot::get_tkij | ( |  | ) | const

inline

Returns the tensor related to the extrinsic curvature tensor by .

`tkij` contains the Cartesian components of .

Definition at line 384 of file star_rot.h.

References tkij.

## get_tnphi()

const Scalar & Lorene::Star_rot::get_tnphi | ( |  | ) | const

inline

Returns the component of the shift vector.

Definition at line 330 of file star_rot.h.

References tnphi.

## get_u_euler()

const Vector & Lorene::Star::get_u_euler | ( |  | ) | const

inline inherited

Returns the fluid 3-velocity with respect to the Eulerian observer.

Definition at line 385 of file star.h.

References u_euler.

## get_uuu()

const Scalar & Lorene::Star_rot::get_uuu | ( |  | ) | const

inline

Returns the norm of `u_euler`.

Definition at line 333 of file star_rot.h.

References uuu.

## get_w_shift()

const Vector & Lorene::Star_rot::get_w_shift | ( |  | ) | const

inline

Returns the vector used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 363 of file star_rot.h.

References w_shift.

## grv2()

double Lorene::Star_rot::grv2 | ( |  | ) | const

virtual

Error on the virial identity GRV2.

This indicator is only valid for relativistic computations.

Definition at line 204 of file star_rot_global.C.

References a_car, ak_car, Lorene::Star::ener_euler, lambda_grv2(), Lorene::Star::logn, Lorene::Star::mp, Lorene::Star::nbar, p_grv2, Lorene::Star::press, relativistic, and uuu.

## grv3()

double Lorene::Star_rot::grv3 | ( | ostream * | ost = 0x0 | ) | const

virtual

Error on the virial identity GRV3.

The error is computed as the integral defined by Eq. (43) of [Gourgoulhon and Bonazzola, Class. Quantum Grav. 11, 443 (1994)] divided by the integral of the matter terms.

Parameters

  ost | output stream to give details of the computation; if set to 0x0 [default value], no details will be given.

Definition at line 235 of file star_rot_global.C.

References a_car, ak_car, bbb, Lorene::Scalar::derive_cov(), Lorene::Scalar::dsdr(), dzeta, Lorene::Scalar::get_dzpuis(), Lorene::Scalar::get_etat(), Lorene::Scalar::integrale(), Lorene::log(), Lorene::Star::logn, Lorene::Star::mp, Lorene::Valeur::mult_ct(), Lorene::Star::nbar, p_grv3, Lorene::Star::press, relativistic, Lorene::Star::s_euler, Lorene::Scalar::set_dzpuis(), Lorene::Scalar::set_spectral_va(), Lorene::Scalar::srdsdt(), Lorene::Valeur::ssint(), Lorene::Scalar::std_spectral_base(), Lorene::Valeur::sx(), uuu, and Lorene::Map_radial::xsr.

## hydro_euler()

void Lorene::Star_rot::hydro_euler | ( |  | ) |

virtual

Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame.

The calculation is performed starting from the quantities `ent` , `ener` , `press` , and `a_car` ,
which are supposed to be up to date.
From these, the following fields are updated: `gam_euler` , `u_euler` , `ener_euler` , `s_euler` .

Reimplemented from Lorene::Star.

Definition at line 57 of file star_rot_hydro.C.

References a_car, b_car, Lorene::Star::beta, Lorene::Vector::change_triad(), del_deriv(), Lorene::Star::ener, Lorene::Star::ener_euler, Lorene::Star::gam_euler, Lorene::Star::mp, Lorene::Star::nn, omega, Lorene::Star::press, Lorene::Star::s_euler, Lorene::sqrt(), Lorene::Star::u_euler, unsurc2, uuu, Lorene::x, and Lorene::y.

## is_relativistic()

bool Lorene::Star_rot::is_relativistic | ( |  | ) | const

inline

Returns `true` for a relativistic star, `false` for a Newtonian one.

Definition at line 308 of file star_rot.h.

References relativistic.

## l_surf()

const Itbl & Lorene::Star_rot::l_surf | ( |  | ) | const

virtual

Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent` ) vanishes.

Reimplemented from Lorene::Star.

Definition at line 68 of file star_rot_global.C.

References Lorene::Star::ent, Lorene::Star::mp, Lorene::Star::nzet, Lorene::Star::p_l_surf, and Lorene::Star::p_xi_surf.

## lambda_grv2()

double Lorene::Star_rot::lambda_grv2 | ( | const Scalar & | sou_m,
|  | const Scalar & | sou_q )

static

Computes the coefficient which ensures that the GRV2 virial identity is satisfied.

is the coefficient by which one must multiply the quadratic source term of the 2-D Poisson equation

in order that the total source does not contain any monopolar term, i.e. in order that

where . is computed according to the formula

Then, by construction, the new source has a vanishing monopolar term.

Parameters

  sou_m | [input] matter source term
  sou_q | [input] quadratic source term

Returns
  value of

Definition at line 62 of file star_rot_lambda_grv2.C.

References Lorene::Scalar::check_dzpuis(), Lorene::Valeur::coef_i(), Lorene::Map_radial::dxdr, Lorene::Map_af::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Scalar::get_etat(), Lorene::Tbl::get_etat(), Lorene::Valeur::get_etat(), Lorene::Mg3d::get_grille3d(), Lorene::Tensor::get_mp(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Scalar::get_spectral_va(), Lorene::Mg3d::get_type_r(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Mtbl::t, Lorene::Tbl::t, Lorene::Grille3d::x, and Lorene::Map_radial::xsr.

## lspec_isco()

double Lorene::Star_rot::lspec_isco | ( |  | ) | const

virtual

Angular momentum of a particle on the ISCO.

Definition at line 272 of file star_rot_isco.C.

References p_lspec_isco, and r_isco().

## mass_b()

double Lorene::Star_rot::mass_b | ( |  | ) | const

virtual

Baryon mass.

Implements Lorene::Star.

Definition at line 98 of file star_rot_global.C.

References a_car, bbb, Lorene::Star::gam_euler, Lorene::Scalar::integrale(), Lorene::Star::nbar, Lorene::Star::p_mass_b, and relativistic.

## mass_g()

double Lorene::Star_rot::mass_g | ( |  | ) | const

virtual

Gravitational mass.

Implements Lorene::Star.

Definition at line 124 of file star_rot_global.C.

References a_car, bbb, Lorene::Star::ener_euler, Lorene::Scalar::integrale(), mass_b(), Lorene::Star::nn, Lorene::Star::p_mass_g, Lorene::Star::press, relativistic, Lorene::Star::s_euler, Lorene::Scalar::std_spectral_base(), tnphi, and uuu.

## mean_radius()

double Lorene::Star_rot::mean_radius | ( |  | ) | const

virtual

Mean star radius from the area .

Definition at line 416 of file star_rot_global.C.

References area(), and Lorene::sqrt().

## mom_quad()

double Lorene::Star_rot::mom_quad | ( |  | ) | const

virtual

Quadrupole moment.

The quadrupole moment Q is defined according to Eq. (7) of [Salgado, Bonazzola, Gourgoulhon and Haensel, Astron. Astrophys. 291 , 155 (1994)]. At the Newtonian limit it is related to the component of the MTW (1973) reduced quadrupole moment by: . Note that Q is the negative of the quadrupole moment defined by Laarakkers and Poisson, Astrophys. J. 512 , 282 (1999).

Definition at line 521 of file star_rot_global.C.

References a_car, ak_car, bbb, Lorene::Scalar::check_dzpuis(), Lorene::Scalar::derive_cov(), Lorene::Star::ener_euler, Lorene::Scalar::get_etat(), Lorene::Scalar::inc_dzpuis(), Lorene::Scalar::integrale(), Lorene::log(), Lorene::Star::logn, Lorene::Star::mp, Lorene::Valeur::mult_ct(), Lorene::Scalar::mult_r(), Lorene::Star::nbar, p_mom_quad, relativistic, Lorene::Star::s_euler, Lorene::Scalar::set_spectral_va(), and Lorene::Scalar::std_spectral_base().

## operator=()

void Lorene::Star_rot::operator= | ( | const Star_rot & | et | ) |

Assignment to another `Star_rot`.

Definition at line 359 of file star_rot.C.

References a_car, ak_car, b_car, bbb, del_deriv(), dzeta, khi_shift, nphi, nuf, nuq, omega, Lorene::Star::operator=(), relativistic, ssjm1_dzeta, ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, Star_rot(), tggg, tkij, tnphi, unsurc2, uuu, and w_shift.

## operator>>()

ostream & Lorene::Star_rot::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Star.

Reimplemented in Lorene::Gravastar.

Definition at line 428 of file star_rot.C.

References a_car, angu_mom(), aplat(), area(), b_car, Lorene::diffrel(), dzeta, f_isco(), get_omega_c(), Lorene::Tbl::get_taille(), grv2(), grv3(), khi_shift, Lorene::Star::logn, mass_g(), mean_radius(), mom_quad(), Lorene::Star::mp, nphi, Lorene::Star::nzet, omega, Lorene::Star::operator>>(), Lorene::pow(), r_circ(), r_isco(), Lorene::Star::ray_eq(), relativistic, Lorene::sqrt(), tsw(), uuu, w_shift, z_eqb(), z_eqf(), and z_pole().

## partial_display()

void Lorene::Star_rot::partial_display | ( | ostream & | ost | ) | const

protected virtual

Printing of some informations, excluding all global quantities.

Definition at line 590 of file star_rot.C.

References a_car, aplat(), b_car, dzeta, Lorene::Star::ener, Lorene::Star::ent, get_omega_c(), Lorene::Star::logn, Lorene::Star::mp, Lorene::Star::nbar, Lorene::Star::nn, nphi, Lorene::Star::nzet, Lorene::Star::press, Lorene::Star::ray_eq(), and uuu.

## r_circ()

double Lorene::Star_rot::r_circ | ( |  | ) | const

virtual

Circumferential radius.

Definition at line 342 of file star_rot_global.C.

References bbb, Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Star::mp, Lorene::Star::nzet, p_r_circ, and Lorene::Star::ray_eq().

## r_isco()

double Lorene::Star_rot::r_isco | ( | ostream * | ost = 0x0 | ) | const

virtual

Circumferential radius of the innermost stable circular orbit (ISCO).

Parameters

  ost | output stream to give details of the computation; if set to 0x0 [default value], no details will be given.

Definition at line 71 of file star_rot_isco.C.

References Lorene::Param::add_int(), Lorene::Param::add_scalar(), Lorene::Tensor::annule_domain(), bbb, Lorene::Scalar::dsdr(), Lorene::Scalar::get_spectral_va(), Lorene::Star::mp, Lorene::Star::nn, nphi, Lorene::Star::nzet, p_espec_isco, p_f_eq, p_f_isco, p_lspec_isco, p_r_isco, Lorene::r, Lorene::Star::ray_eq(), Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), Lorene::Valeur::val_point(), and Lorene::zerosec().

## ray_eq()

double Lorene::Star::ray_eq | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 108 of file star_global.C.

References Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq, Lorene::phi, and xi_surf().

## ray_eq_3pis2()

double Lorene::Star::ray_eq_3pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 233 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_3pis2, Lorene::phi, ray_eq_pis2(), and xi_surf().

## ray_eq_pi()

double Lorene::Star::ray_eq_pi | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 186 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pi, Lorene::phi, ray_eq(), and xi_surf().

## ray_eq_pis2()

double Lorene::Star::ray_eq_pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 138 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pis2, Lorene::phi, and xi_surf().

## ray_pole()

double Lorene::Star::ray_pole | ( |  | ) | const

inherited

Coordinate radius at [r_unit].

Definition at line 278 of file star_global.C.

References Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_pole, Lorene::phi, and xi_surf().

## sauve()

void Lorene::Star_rot::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Star.

Definition at line 401 of file star_rot.C.

References dzeta, Lorene::fwrite_be(), khi_shift, nuf, nuq, omega, relativistic, Lorene::Star::sauve(), ssjm1_dzeta, ssjm1_khi, ssjm1_nuf, ssjm1_nuq, ssjm1_tggg, ssjm1_wshift, tggg, and w_shift.

## set_der_0x0()

void Lorene::Star_rot::set_der_0x0 | ( |  | ) | const

protected virtual

Sets to `0x0` all the pointers on derived quantities.

Reimplemented from Lorene::Star.

Definition at line 322 of file star_rot.C.

References p_angu_mom, p_aplat, p_area, p_espec_isco, p_f_eq, p_f_isco, p_grv2, p_grv3, p_lspec_isco, p_mom_quad, p_r_circ, p_r_isco, p_tsw, p_z_eqb, p_z_eqf, p_z_pole, and Lorene::Star::set_der_0x0().

## set_enthalpy()

void Lorene::Star::set_enthalpy | ( | const Scalar & | ent_i | ) |

inherited

Assignment of the enthalpy field.

Definition at line 379 of file star.C.

References del_deriv(), ent, and equation_of_state().

## set_mp()

Map & Lorene::Star::set_mp | ( |  | ) |

inline inherited

Read/write of the mapping.

Definition at line 322 of file star.h.

References Lorene::Map(), and mp.

## tsw()

double Lorene::Star_rot::tsw | ( |  | ) | const

virtual

Ratio T/W.

Definition at line 176 of file star_rot_global.C.

References a_car, angu_mom(), bbb, Lorene::Star::ener, Lorene::Star::gam_euler, Lorene::Scalar::integrale(), Lorene::Star::logn, mass_g(), Lorene::Star::nbar, omega, p_tsw, and relativistic.

## update_metric()

void Lorene::Star_rot::update_metric | ( |  | ) |

Computes metric coefficients from known potentials.

The calculation is performed starting from the quantities `logn` , `dzeta` , `tggg` and `shift` , which are supposed to be up to date.
From these, the following fields are updated: `nnn` , `a_car` , `bbb` and `b_car`, as well as the 3-metric `gamma`.

Definition at line 51 of file star_rot_upmetr.C.

References a_car, b_car, bbb, del_deriv(), Lorene::Scalar::div_rsint(), dzeta, Lorene::exp(), extrinsic_curvature(), Lorene::Star::gamma, Lorene::Star::logn, Lorene::Star::mp, Lorene::Star::nn, Lorene::Tensor::set(), tggg, and unsurc2.

## xi_surf()

const Tbl & Lorene::Star::xi_surf | ( |  | ) | const

inherited

Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent`) vanishes.

Definition at line 89 of file star_global.C.

References l_surf(), p_l_surf, and p_xi_surf.

## z_eqb()

double Lorene::Star_rot::z_eqb | ( |  | ) | const

virtual

Backward redshift factor at equator.

Definition at line 471 of file star_rot_global.C.

References Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Star::mp, Lorene::Star::nn, nphi, Lorene::Star::nzet, p_z_eqb, r_circ(), Lorene::sqrt(), and uuu.

## z_eqf()

double Lorene::Star_rot::z_eqf | ( |  | ) | const

virtual

Forward redshift factor at equator.

Definition at line 443 of file star_rot_global.C.

References Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_t(), Lorene::Star::mp, Lorene::Star::nn, nphi, Lorene::Star::nzet, p_z_eqf, r_circ(), Lorene::sqrt(), and uuu.

## z_pole()

double Lorene::Star_rot::z_pole | ( |  | ) | const

virtual

Redshift factor at North pole.

Definition at line 502 of file star_rot_global.C.

References Lorene::Star::nn, p_z_pole, and Lorene::Star::ray_pole().

## Member Data Documentation

## a_car

Scalar Lorene::Star_rot::a_car

protected

Square of the metric factor A.

Definition at line 104 of file star_rot.h.

## ak_car

Scalar Lorene::Star_rot::ak_car

protected

Scalar .

For axisymmetric stars, this quantity is related to the derivatives of by

In particular it is related to the quantities and introduced by Eqs.~(3.7) and (3.8) of Bonazzola et al. Astron. Astrophys. 278 , 421 (1993) by

Definition at line 186 of file star_rot.h.

## b_car

Scalar Lorene::Star_rot::b_car

protected

Square of the metric factor B.

Definition at line 110 of file star_rot.h.

## bbb

Scalar Lorene::Star_rot::bbb

protected

Metric factor B.

Definition at line 107 of file star_rot.h.

## beta

Vector Lorene::Star::beta

protected inherited

Shift vector.

Definition at line 228 of file star.h.

## dzeta

Scalar Lorene::Star_rot::dzeta

protected

Metric potential .

Definition at line 134 of file star_rot.h.

## ener

Scalar Lorene::Star::ener

protected inherited

Total energy density in the fluid frame.

Definition at line 193 of file star.h.

## ener_euler

Scalar Lorene::Star::ener_euler

protected inherited

Total energy density in the Eulerian frame.

Definition at line 198 of file star.h.

## ent

Scalar Lorene::Star::ent

protected inherited

Log-enthalpy.

Definition at line 190 of file star.h.

## eos

const Eos& Lorene::Star::eos

protected inherited

Equation of state of the stellar matter.

Definition at line 185 of file star.h.

## gam_euler

Scalar Lorene::Star::gam_euler

protected inherited

Lorentz factor between the fluid and Eulerian observers.

Definition at line 204 of file star.h.

## gamma

Metric Lorene::Star::gamma

protected inherited

3-metric

Definition at line 235 of file star.h.

## khi_shift

Scalar Lorene::Star_rot::khi_shift

protected

Scalar used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

Definition at line 160 of file star_rot.h.

## lnq

Scalar Lorene::Star::lnq

protected inherited

Definition at line 232 of file star.h.

## logn

Scalar Lorene::Star::logn

protected inherited

Logarithm of the lapse N .

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 222 of file star.h.

## mp

Map& Lorene::Star::mp

protected inherited

Mapping associated with the star.

Definition at line 180 of file star.h.

## nbar

Scalar Lorene::Star::nbar

protected inherited

Baryon density in the fluid frame.

Definition at line 192 of file star.h.

## nn

Scalar Lorene::Star::nn

protected inherited

Lapse function N .

Definition at line 225 of file star.h.

## nphi

Scalar Lorene::Star_rot::nphi

protected

Metric coefficient .

Definition at line 113 of file star_rot.h.

## nuf

Scalar Lorene::Star_rot::nuf

protected

Part of the Metric potential = `logn` generated by the matter terms.

Definition at line 126 of file star_rot.h.

## nuq

Scalar Lorene::Star_rot::nuq

protected

Part of the Metric potential = `logn` generated by the quadratic terms.

Definition at line 131 of file star_rot.h.

## nzet

int Lorene::Star::nzet

protected inherited

Number of domains of `*mp` occupied by the star.

Definition at line 183 of file star.h.

## omega

double Lorene::Star_rot::omega

protected

Rotation angular velocity (``[f_unit] ).

Definition at line 101 of file star_rot.h.

## p_angu_mom

double* Lorene::Star_rot::p_angu_mom

mutable protected

Angular momentum.

Definition at line 232 of file star_rot.h.

## p_aplat

double* Lorene::Star_rot::p_aplat

mutable protected

Flatening r_pole/r_eq.

Definition at line 237 of file star_rot.h.

## p_area

double* Lorene::Star_rot::p_area

mutable protected

Integrated surface area.

Definition at line 238 of file star_rot.h.

## p_espec_isco

double* Lorene::Star_rot::p_espec_isco

mutable protected

Specific energy of a particle on the ISCO.

Definition at line 246 of file star_rot.h.

## p_f_eq

double* Lorene::Star_rot::p_f_eq

mutable protected

Orbital frequency at the equator.

Definition at line 249 of file star_rot.h.

## p_f_isco

double* Lorene::Star_rot::p_f_isco

mutable protected

Orbital frequency of the ISCO.

Definition at line 244 of file star_rot.h.

## p_grv2

double* Lorene::Star_rot::p_grv2

mutable protected

Error on the virial identity GRV2.

Definition at line 234 of file star_rot.h.

## p_grv3

double* Lorene::Star_rot::p_grv3

mutable protected

Error on the virial identity GRV3.

Definition at line 235 of file star_rot.h.

## p_l_surf

Itbl* Lorene::Star::p_l_surf

mutable protected inherited

Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

Definition at line 260 of file star.h.

## p_lspec_isco

double* Lorene::Star_rot::p_lspec_isco

mutable protected

Specific angular momentum of a particle on the ISCO.

Definition at line 248 of file star_rot.h.

## p_mass_b

double* Lorene::Star::p_mass_b

mutable protected inherited

Baryon mass.

Definition at line 268 of file star.h.

## p_mass_g

double* Lorene::Star::p_mass_g

mutable protected inherited

Gravitational mass.

Definition at line 269 of file star.h.

## p_mom_quad

double* Lorene::Star_rot::p_mom_quad

mutable protected

Quadrupole moment.

Definition at line 242 of file star_rot.h.

## p_r_circ

double* Lorene::Star_rot::p_r_circ

mutable protected

Circumferential radius.

Definition at line 236 of file star_rot.h.

## p_r_isco

double* Lorene::Star_rot::p_r_isco

mutable protected

Circumferential radius of the ISCO.

Definition at line 243 of file star_rot.h.

## p_ray_eq

double* Lorene::Star::p_ray_eq

mutable protected inherited

Coordinate radius at , .

Definition at line 242 of file star.h.

## p_ray_eq_3pis2

double* Lorene::Star::p_ray_eq_3pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 251 of file star.h.

## p_ray_eq_pi

double* Lorene::Star::p_ray_eq_pi

mutable protected inherited

Coordinate radius at , .

Definition at line 248 of file star.h.

## p_ray_eq_pis2

double* Lorene::Star::p_ray_eq_pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 245 of file star.h.

## p_ray_pole

double* Lorene::Star::p_ray_pole

mutable protected inherited

Coordinate radius at .

Definition at line 254 of file star.h.

## p_tsw

double* Lorene::Star_rot::p_tsw

mutable protected

Ratio T/W.

Definition at line 233 of file star_rot.h.

## p_xi_surf

Tbl* Lorene::Star::p_xi_surf

mutable protected inherited

Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

Definition at line 266 of file star.h.

## p_z_eqb

double* Lorene::Star_rot::p_z_eqb

mutable protected

Backward redshift factor at equator.

Definition at line 240 of file star_rot.h.

## p_z_eqf

double* Lorene::Star_rot::p_z_eqf

mutable protected

Forward redshift factor at equator.

Definition at line 239 of file star_rot.h.

## p_z_pole

double* Lorene::Star_rot::p_z_pole

mutable protected

Redshift factor at North pole.

Definition at line 241 of file star_rot.h.

## press

Scalar Lorene::Star::press

protected inherited

Fluid pressure.

Definition at line 194 of file star.h.

## relativistic

bool Lorene::Star_rot::relativistic

protected

Indicator of relativity: `true` for a relativistic star, `false` for a Newtonian one.

Definition at line 94 of file star_rot.h.

## s_euler

Scalar Lorene::Star::s_euler

protected inherited

Trace of the stress scalar in the Eulerian frame.

Definition at line 201 of file star.h.

## ssjm1_dzeta

Scalar Lorene::Star_rot::ssjm1_dzeta

protected

Effective source at the previous step for the resolution of the Poisson equation for `dzeta` .

Definition at line 203 of file star_rot.h.

## ssjm1_khi

Scalar Lorene::Star_rot::ssjm1_khi

protected

Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector

Definition at line 216 of file star_rot.h.

## ssjm1_nuf

Scalar Lorene::Star_rot::ssjm1_nuf

protected

Effective source at the previous step for the resolution of the Poisson equation for `nuf` by means of `Map_et::poisson` .

Definition at line 192 of file star_rot.h.

## ssjm1_nuq

Scalar Lorene::Star_rot::ssjm1_nuq

protected

Effective source at the previous step for the resolution of the Poisson equation for `nuq` by means of `Map_et::poisson` .

Definition at line 198 of file star_rot.h.

## ssjm1_tggg

Scalar Lorene::Star_rot::ssjm1_tggg

protected

Effective source at the previous step for the resolution of the Poisson equation for `tggg` .

Definition at line 208 of file star_rot.h.

## ssjm1_wshift

Vector Lorene::Star_rot::ssjm1_wshift

protected

Effective source at the previous step for the resolution of the vector Poisson equation for .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector (Components with respect to the Cartesian triad associated with the mapping `mp` )

Definition at line 225 of file star_rot.h.

## stress_euler

Sym_tensor Lorene::Star::stress_euler

protected inherited

Spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 212 of file star.h.

## tggg

Scalar Lorene::Star_rot::tggg

protected

Metric potential .

Definition at line 137 of file star_rot.h.

## tkij

Sym_tensor Lorene::Star_rot::tkij

protected

Tensor related to the extrinsic curvature tensor by .

`tkij` contains the Cartesian components of .

Definition at line 167 of file star_rot.h.

## tnphi

Scalar Lorene::Star_rot::tnphi

protected

Component of the shift vector.

Definition at line 118 of file star_rot.h.

## u_euler

Vector Lorene::Star::u_euler

protected inherited

Fluid 3-velocity with respect to the Eulerian observer.

Definition at line 207 of file star.h.

## unsurc2

double Lorene::Star_rot::unsurc2

protected

: `unsurc2=1` for a relativistic star, 0 for a Newtonian one.

Definition at line 99 of file star_rot.h.

## uuu

Scalar Lorene::Star_rot::uuu

protected

Norm of `u_euler`.

Definition at line 121 of file star_rot.h.

## w_shift

Vector Lorene::Star_rot::w_shift

protected

Vector used in the decomposition of `shift` , following Shibata's prescription [Prog.

Theor. Phys. 101 , 1199 (1999)] :

NB: `w_shift` contains the components of with respect to the Cartesian triad associated with the mapping `mp` .

Definition at line 150 of file star_rot.h.

The documentation for this class was generated from the following files:

- star_rot.h
- star_rot.C
- star_rot_equil.C
- star_rot_global.C
- star_rot_hydro.C
- star_rot_isco.C
- star_rot_lambda_grv2.C
- star_rot_upmetr.C